; -------------------------------------------------------------------------
; #########################################################################
; -------------------------------------------------------------------------
; Dynamic Loading Bassmod.dll Demo \ SeRGe
; -------------------------------------------------------------------------
; #########################################################################
; -------------------------------------------------------------------------
.686
.model flat,stdcall
option casemap:none
; -------------------------------------------------------------------------
;include files
include\masm32\include\windows.inc
include\masm32\include\kernel32.inc
include\masm32\include\user32.inc
include\masm32\include\gdi32.inc
;libraries
includelib\masm32\lib\kernel32.lib
includelib\masm32\lib\user32.lib
includelib\masm32\lib\gdi32.lib
includelib	\masm32\lib\masm32.lib
include PEmem.inc
includelib PEmem.lib
; -------------------------------------------------------------------------
;macros
include\masm32\macros\macros.asm
; -------------------------------------------------------------------------
;protos
DlgProc         PROTO :DWORD,:DWORD,:DWORD,:DWORD
ExtRes          PROTO :DWORD,:DWORD
EXTERN	pDLL:PTR BYTE                         	; pointer to ConsoleOut.dll linked together with

; -------------------------------------------------------------------------
.const
IDD_DIALOG      equ 300
IDR_BASSMOD     equ 400
IDM_MUSIC       equ 500
; -------------------------------------------------------------------------
.data

szLibName       TCHAR   "bassmod.dll",0
szFileName      TCHAR   "\bassmod.dll",0
pPathBuffer     LPTSTR  (MAX_PATH+11) dup (?)
pFileSize       LPDWORD (34308)

; -------------------------------------------------------------------------
.data?
hInstance       HINSTANCE           ?
hModule         HMODULE             ?

wfd             WIN32_FIND_DATA    <?>
pBytesWritten   LPDWORD             ?
pEntry		dd ?
; -------------------------------------------------------------------------
; #########################################################################
; -------------------------------------------------------------------------
.code
; -------------------------------------------------------------------------
; #########################################################################
; -------------------------------------------------------------------------
start:  invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  DialogBoxParam,eax,IDD_DIALOG,NULL,ADDR DlgProc,NULL
        invoke  ExitProcess,eax
; -------------------------------------------------------------------------
; #########################################################################
; -------------------------------------------------------------------------
DlgProc proc    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov eax,[uMsg]
        .if [uMsg]==WM_INITDIALOG
            invoke  ExtRes,ADDR szFileName,IDR_BASSMOD
            or      eax,FALSE
            jz      @quit
          ;  invoke  LoadLibrary,ADDR szLibName

            invoke LoadEXEfromMem,ADDR pDLL,ADDR pEntry


            mov     hModule,eax
            invoke  GetProcAddr,hModule,CADD("BASSMOD_Init")
            mov     ebx,eax
            or      eax,eax
            jz      @error
            invoke  GetProcAddr,hModule,CADD("BASSMOD_MusicLoad")
            mov     esi,eax
            or      eax,eax
            jz      @error
            invoke  GetProcAddr,hModule,CADD("BASSMOD_MusicPlay")
            mov     edi,eax
            or      eax,eax
            jnz     @F
@error:     invoke  MessageBox,hWnd,CADD("GET_PROCESS_ADDRESS_ERROR"),
                                    ADDR szAppName,MB_ICONERROR
            jmp     @quit
@@:         invoke  FindResource,hInstance,IDM_MUSIC,RT_RCDATA
            invoke  LoadResource,hInstance,eax
            push    eax
            push    0
            push    44100
            push    -1
            call    ebx
            pop     eax
            push    2
            push    4
            push    0
            push    0
            push    eax
            push    1
            call    esi
            call    edi

        .elseif [uMsg]==WM_RBUTTONDOWN
            invoke  SendMessage,hWnd,WM_CLOSE,NULL,NULL
        .elseif [uMsg]==WM_CLOSE
@quit:      invoke  FreeLibrary,hModule
            invoke  EndDialog,hWnd,NULL
        .endif
        xor eax,eax
        ret

DlgProc endp
; -------------------------------------------------------------------------
; #########################################################################
; -------------------------------------------------------------------------
ExtRes  proc    pFileName:LPCTSTR,pResource:LPCTSTR

        invoke  GetSystemDirectory,ADDR pPathBuffer,MAX_PATH
        invoke  lstrcat,ADDR pPathBuffer,pFileName
        invoke  FindFirstFile,eax,ADDR wfd
        cmp     eax,INVALID_HANDLE_VALUE
        jz      @F
        invoke  FindClose,eax
        mov     eax,wfd.nFileSizeLow
        cmp     eax,pFileSize
        jz      @ret
@@:     invoke  FindResource,hInstance,pResource,RT_RCDATA
        push    eax
        invoke  SizeofResource,hInstance,eax
        mov     edi,eax
        pop     eax
        invoke  LoadResource,hInstance,eax
        mov     esi,eax
        invoke  LockResource,eax
        invoke  CreateFile,ADDR pPathBuffer,GENERIC_WRITE,
                                            FILE_SHARE_READ,
                                            NULL,
                                            CREATE_ALWAYS,
                                            FILE_ATTRIBUTE_NORMAL,
                                            NULL
        cmp     eax,INVALID_HANDLE_VALUE
        jz      @error
        mov     ebx,eax
        lea     ecx,pBytesWritten
        invoke  WriteFile,ebx,esi,edi,ecx,NULL
        invoke  CloseHandle,ebx
        or      eax,eax
        jnz     @ret
@error: invoke  MessageBox,NULL,CADD("INVALID_HANDLE_VALUE"),
                                ADDR szAppName,MB_ICONERROR
        mov     eax,FALSE
@ret:   ret

ExtRes  endp
; -------------------------------------------------------------------------
; #########################################################################
; -------------------------------------------------------------------------
end start
; -------------------------------------------------------------------------
; #########################################################################
; -------------------------------------------------------------------------